3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
39 OK_TO_SKIP_PRE_REBASE=
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
48 dotest="$GIT_DIR"/rebase-merge
51 diffstat=$(git config --bool rebase.stat)
55 allow_rerere_autoupdate=
58 test -n "$prev_head" || die "prev_head must be defined"
59 test -d "$dotest" || die "$dotest directory does not exist"
61 unmerged=$(git ls-files -u)
62 if test -n "$unmerged"
64 echo "You still have unmerged paths in your index"
65 echo "did you forget to use git add?"
69 cmt=`cat "$dotest/current"`
70 if ! git diff-index --quiet --ignore-submodules HEAD --
72 if ! git commit --no-verify -C "$cmt"
74 echo "Commit failed, please do not call \"git commit\""
75 echo "directly, but instead do one of the following: "
78 if test -z "$GIT_QUIET"
80 printf "Committed: %0${prec}d " $msgnum
83 if test -z "$GIT_QUIET"
85 printf "Already applied: %0${prec}d " $msgnum
88 test -z "$GIT_QUIET" &&
89 GIT_PAGER='' git log --format=%s -1 "$cmt"
91 prev_head=`git rev-parse HEAD^0`
92 # save the resulting commit so we can read-tree on it later
93 echo "$prev_head" > "$dotest/prev_head"
95 # onto the next patch:
96 msgnum=$(($msgnum + 1))
97 echo "$msgnum" >"$dotest/msgnum"
101 cmt="$(cat "$dotest/cmt.$1")"
102 echo "$cmt" > "$dotest/current"
103 hd=$(git rev-parse --verify HEAD)
104 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
105 msgnum=$(cat "$dotest/msgnum")
106 end=$(cat "$dotest/end")
107 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
108 eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
109 export GITHEAD_$cmt GITHEAD_$hd
110 if test -n "$GIT_QUIET"
112 export GIT_MERGE_VERBOSITY=1
114 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
118 unset GITHEAD_$cmt GITHEAD_$hd
122 git rerere $allow_rerere_autoupdate
126 echo "Strategy: $rv $strategy failed, try another" 1>&2
130 die "Unknown exit code ($rv) from command:" \
131 "git-merge-$strategy $cmt^ -- HEAD $cmt"
136 move_to_original_branch () {
137 test -z "$head_name" &&
138 head_name="$(cat "$dotest"/head-name)" &&
139 onto="$(cat "$dotest"/onto)" &&
140 orig_head="$(cat "$dotest"/orig-head)"
143 message="rebase finished: $head_name onto $onto"
144 git update-ref -m "$message" \
145 $head_name $(git rev-parse HEAD) $orig_head &&
146 git symbolic-ref HEAD $head_name ||
147 die "Could not move back to $head_name"
153 move_to_original_branch
163 interactive_rebase=explicit
166 -p|--preserve-merges)
167 interactive_rebase=implied
173 if [ "$interactive_rebase" = implied ]; then
178 test -n "$interactive_rebase" || test -f "$dotest"/interactive
181 run_pre_rebase_hook () {
182 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
183 test -x "$GIT_DIR/hooks/pre-rebase"
185 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
186 die "The pre-rebase hook refused to rebase."
190 test -f "$GIT_DIR"/rebase-apply/applying &&
191 die 'It looks like git-am is in progress. Cannot rebase.'
193 is_interactive "$@" && exec git-rebase--interactive "$@"
197 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
198 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
199 die 'A rebase is in progress, try --continue, --skip or --abort.'
200 die "No arguments given and $GIT_DIR/rebase-apply already exists."
207 OK_TO_SKIP_PRE_REBASE=yes
210 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
211 die "No rebase in progress?"
213 git diff-files --quiet --ignore-submodules || {
214 echo "You must edit all merge conflicts and then"
215 echo "mark them as resolved using git add"
220 prev_head=$(cat "$dotest/prev_head")
221 end=$(cat "$dotest/end")
222 msgnum=$(cat "$dotest/msgnum")
223 onto=$(cat "$dotest/onto")
224 GIT_QUIET=$(cat "$dotest/quiet")
226 while test "$msgnum" -le "$end"
234 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
235 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
236 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
237 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
238 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
239 move_to_original_branch
243 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
244 die "No rebase in progress?"
246 git reset --hard HEAD || exit $?
250 prev_head=$(cat "$dotest/prev_head")
251 end=$(cat "$dotest/end")
252 msgnum=$(cat "$dotest/msgnum")
253 msgnum=$(($msgnum + 1))
254 onto=$(cat "$dotest/onto")
255 GIT_QUIET=$(cat "$dotest/quiet")
256 while test "$msgnum" -le "$end"
264 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
265 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
266 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
267 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
268 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
269 move_to_original_branch
273 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
274 die "No rebase in progress?"
279 GIT_QUIET=$(cat "$dotest/quiet")
280 move_to_original_branch
282 dotest="$GIT_DIR"/rebase-apply
283 GIT_QUIET=$(cat "$dotest/quiet")
284 move_to_original_branch
286 git reset --hard $(cat "$dotest/orig-head")
291 test 2 -le "$#" || usage
295 -M|-m|--m|--me|--mer|--merg|--merge)
298 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
299 --strateg=*|--strategy=*|\
300 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
303 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
325 git_am_opt="$git_am_opt -q"
330 git_am_opt="$git_am_opt $1"
332 --whitespace=fix|--whitespace=strip)
338 git_am_opt="$git_am_opt $1"
340 --committer-date-is-author-date|--ignore-date)
341 git_am_opt="$git_am_opt $1"
345 git_am_opt="$git_am_opt $1"
350 -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase)
353 --rerere-autoupdate|--no-rerere-autoupdate)
354 allow_rerere_autoupdate="$1"
365 test $# -gt 2 && usage
367 # Make sure we do not have $GIT_DIR/rebase-apply
368 if test -z "$do_merge"
370 if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
372 rmdir "$GIT_DIR"/rebase-apply
375 It seems that I cannot create a rebase-apply directory, and
376 I wonder if you are in the middle of patch application or another
377 rebase. If that is not the case, please
378 rm -fr '"$GIT_DIR"'/rebase-apply
379 and run me again. I am stopping in case you still have something
386 die "previous rebase directory $dotest still exists." \
387 'Try git rebase (--continue | --abort | --skip)'
391 # The tree must be really really clean.
392 if ! git update-index --ignore-submodules --refresh > /dev/null; then
393 echo >&2 "cannot rebase: you have unstaged changes"
394 git diff-files --name-status -r --ignore-submodules -- >&2
397 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
399 ?*) echo >&2 "cannot rebase: your index contains uncommitted changes"
405 if test -z "$rebase_root"
407 # The upstream head must be given. Make sure it is valid.
410 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
411 die "invalid upstream $upstream_name"
413 upstream_arg="$upstream_name"
415 test -z "$newbase" && die "--root must be used with --onto"
419 upstream_arg="$root_flag"
422 # Make sure the branch to rebase onto is valid.
423 onto_name=${newbase-"$upstream_name"}
426 if left=${onto_name%...*} right=${onto_name#*...} &&
427 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
431 die "$onto_name: there are more than one merge bases"
434 die "$onto_name: there is no merge base"
438 die "$onto_name: there is no merge base"
442 onto=$(git rev-parse --verify "${onto_name}^0") || exit
446 # If a hook exists, give it a chance to interrupt
447 run_pre_rebase_hook "$upstream_arg" "$@"
449 # If the branch to rebase is given, that is the branch we will rebase
450 # $branch_name -- branch being rebased, or HEAD (already detached)
451 # $orig_head -- commit object name of tip of the branch before rebasing
452 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
456 # Is it "rebase other $branchname" or "rebase other $commit"?
460 if git show-ref --verify --quiet -- "refs/heads/$1" &&
461 branch=$(git rev-parse -q --verify "refs/heads/$1")
463 head_name="refs/heads/$1"
464 elif branch=$(git rev-parse -q --verify "$1")
466 head_name="detached HEAD"
472 # Do not need to switch branches, we are already on it.
473 if branch_name=`git symbolic-ref -q HEAD`
475 head_name=$branch_name
476 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
478 head_name="detached HEAD"
479 branch_name=HEAD ;# detached
481 branch=$(git rev-parse --verify "${branch_name}^0") || exit
486 # Now we are rebasing commits $upstream..$branch (or with --root,
487 # everything leading up to $branch) on top of $onto
489 # Check if we are already based on $onto with linear history,
490 # but this should be done only when upstream and onto are the same.
491 mb=$(git merge-base "$onto" "$branch")
492 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
494 ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
496 if test -z "$force_rebase"
498 # Lazily switch to the target branch if needed...
499 test -z "$switch_to" || git checkout "$switch_to"
500 say "Current branch $branch_name is up to date."
503 say "Current branch $branch_name is up to date, rebase forced."
507 # Detach HEAD and reset the tree
508 say "First, rewinding head to replay your work on top of it..."
509 git checkout -q "$onto^0" || die "could not detach HEAD"
510 git update-ref ORIG_HEAD $branch
512 if test -n "$diffstat"
514 if test -n "$verbose"
516 echo "Changes from $mb to $onto:"
518 # We want color (if set), but no pager
519 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
522 # If the $onto is a proper descendant of the tip of the branch, then
523 # we just fast-forwarded.
524 if test "$mb" = "$branch"
526 say "Fast-forwarded $branch_name to $onto_name."
527 move_to_original_branch
531 if test -n "$rebase_root"
533 revisions="$onto..$orig_head"
535 revisions="$upstream..$orig_head"
538 if test -z "$do_merge"
540 git format-patch -k --stdout --full-index --ignore-if-in-upstream \
541 $root_flag "$revisions" |
542 git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
543 move_to_original_branch
545 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
546 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
547 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
548 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
549 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
553 # start doing a rebase with git-merge
554 # this is rename-aware if the recursive (default) strategy is used
557 echo "$onto" > "$dotest/onto"
558 echo "$onto_name" > "$dotest/onto_name"
560 echo "$prev_head" > "$dotest/prev_head"
561 echo "$orig_head" > "$dotest/orig-head"
562 echo "$head_name" > "$dotest/head-name"
563 echo "$GIT_QUIET" > "$dotest/quiet"
566 for cmt in `git rev-list --reverse --no-merges "$revisions"`
568 msgnum=$(($msgnum + 1))
569 echo "$cmt" > "$dotest/cmt.$msgnum"
572 echo 1 >"$dotest/msgnum"
573 echo $msgnum >"$dotest/end"
578 while test "$msgnum" -le "$end"